题目
根据每日 气温 列表,请重新生成一个列表,对应位置的输出是需要再等待多久温度才会升高超过该日的天数。如果之后都不会升高,请在该位置用 0 来代替。
例如,给定一个列表 temperatures = [73, 74, 75, 71, 69, 72, 76, 73],你的输出应该是 [1, 1, 4, 2, 1, 1, 0, 0]。
提示:气温 列表长度的范围是 [1, 30000]。每个气温的值的均为华氏度,都是在 [30, 100] 范围内的整数。
来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/daily-temperatures
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。
基本思想1 : 单调栈
本题的本质是求与该元素后,第一个大于该元素的距离。
维护一个单调第减栈,当出现一个破坏该栈的元素时,说明该元素是第一个大于栈内的元素。
class Solution {
public:
vector<int> dailyTemperatures(vector<int>& T) {
if(T.size() == 0)
return {};
//单调栈,保证栈内的元素是单调递减的
stack<int> st;
vector<int> res(T.size(), 0);
st.push(0);
for(int i = 1; i < T.size(); ++i){
if(st.empty() || T[i] <= T[st.top()]){
st.push(i);
}
else{
while(!st.empty() && T[i] > T[st.top()]){
int pos = st.top();
st.pop();
res[pos] = i - pos;
}
st.push(i);
}
}
return res;
}
};
时间复杂度:O(n),因为每个元素最多进栈1次
基本思想2:暴力
也不算是完全暴力吧。
- 从后往前遍历数组,维护一个next数组,数组的下标代表温度,用来保存已经遍历过的数组的位置
- 遍历到该元素时,从比该元素大1的位置开始遍历next数组,寻找最小下标
class Solution {
public:
vector<int> dailyTemperatures(vector<int>& T) {
if(T.size() == 0)
return {};
vector<int> next(101, INT_MAX);
vector<int> res(T.size(), 0);
for(int i = T.size() - 1; i >= 0; --i){
int pos = INT_MAX;
for(int j = T[i] + 1; j <= 100; ++j){
pos = min(pos, next[j]);
}
if(pos != INT_MAX)
res[i] = pos - i;
next[T[i]] = i;
}
return res;
}
};